@ECHO OFF
::	Version 2.0.3
::	02/06/2019 2:30pm
::	Mark Bradley
::
:: ***** DO NOT CONTACT FiTech FOR SUPPORT OF THIS SCRIPT *****
:: =====================================================================================
::
::	Notes:
::	Corrected the date and a few spelling errors.
::	Added a menu, logging and features
:: ====================================================================================
:: This script is completely outside of any supported FiTech service.
:: There is no warranty implied or stated and all support is best effort by the author.
:: If you need support you must contact the Facebook  "FiTech Owners Group" and generate a post to the author.
::
:: Dependencies:
:: For the script to function the following conditions must be satisfied:
::	The Fitech handheld must be connected to a Windows based computer
::	The Handheld must be recognized as a drive letter of (D, E, or H)
::	This script must be placed on the Windows computer you are working from (Preferred on the root of the Handheld)
:: The script is very simple so that it will work on old and new computers alike therefor I am not trying to suppress systems all messages.
:: The script creates a simple log (Log.txt) located wherever you run the script from.
::
=====================================================================================
:: 
:: ACTIONS
:: - Find the drive containing the FiTech folders	
::  - Backup your Handheld Configs
::  - Restore your Handheld Configs from Backup
::  - Establish the initial log_file folder in the event that is needed 
::  - Repair logging that once worked and is now broken
::
:: By default the script will take no action other than to present the MENU and add a time & date stamp into a log file (log.txt).
:: This is NOT the FiTech log file but a log that lets the author know what you did if help is needed.
::
:: *****************  The script begins below this point ********************

:TOP
SET DRIVE=0
:BEGIN
SET INPUT=0
SET ACTION=0

ECHO.
ECHO ...............................................
ECHO PRESS 1, 2, 3, 4 to select your task, or 5 to EXIT.
ECHO ...............................................
ECHO.
ECHO 1 - Backup My Handheld Configs
ECHO 2 - Restore My Handheld Configs from Backup
ECHO 3 - Logging has never worked
ECHO 4 - Logging worked and is now broken
ECHO 5 - EXIT
ECHO.
SET /P INPUT=Type 1, 2, 3, or 4 then press ENTER: 
IF %INPUT%==5 ECHO You exited the utility >>%cd%\log.txt
IF %INPUT%==5 GOTO EOF

IF %DRIVE%!=0 GOTO MENU

@ECHO off
date /t >>%cd%\log.txt
time /t >>%cd%\log.txt
ECHO You typed %INPUT% >>%cd%\log.txt

:: Check to see where the FiTech folder structure is located using common drive letters

:Check_D
@ECHO Off
dir /b D:\cal_file\ >nul
IF %ERRORLEVEL% ==1 ECHO D:\Cal_file does not exist >>%cd%\log.txt
IF %ERRORLEVEL% ==1 GOTO Check_E
IF %ERRORLEVEL% ==0 ECHO D:\Cal_file exist >>%cd%\log.txt
SET DRIVE=D
GOTO MENU

:Check_E
@ECHO Off
dir /b E:\cal_file\ >nul
IF %ERRORLEVEL% ==1 ECHO E:\Cal_file does not exist >>%cd%\log.txt
IF %ERRORLEVEL% ==1 GOTO Check_H 
IF %ERRORLEVEL% ==0 ECHO E:\Cal_file exist >>%cd%\log.txt
SET DRIVE=E
GOTO MENU

:Check_H
@ECHO Off
dir /b H:\cal_file\ >nul
IF %ERRORLEVEL%==1 ECHO H:\Cal_file does not exist >>%cd%\log.txt
IF %ERRORLEVEL%==1 GOTO EOF
IF %ERRORLEVEL%==0 ECHO H:\Cal_file exist >>%cd%\log.txt
SET DRIVE=H
GOTO MENU

:MENU

IF %INPUT%==1 GOTO BACKUP
IF %INPUT%==2 GOTO RESTORE
IF %INPUT%==3 GOTO NEWLOG
IF %INPUT%==4 GOTO FIXLOG
IF %INPUT%==5 GOTO EOF
ECHO The MENU option you selected is not valid
ECHO The MENU option you selected (%INPUT%) is invalid>>%cd%\log.txt
CLS
@ECHO OFF
GOTO TOP
:: Create folders and or restore files.
:: If the folders already exist it simply throws a transparent error and moves on.

:BACKUP
@ECHO Off
set action=BACKUP
mkdir %DRIVE%:\cal_file_backup
Copy /y %DRIVE%:\cal_file\*.cal %DRIVE%:\cal_file_Backup\
CLS
GOTO STATE

:RESTORE
@ECHO Off
set action=RESTORE

copy /y %DRIVE%:\cal_file_Backup\*.cal %DRIVE%:\Cal_File\
CLS
GOTO STATE

:NEWLOG
@ECHO Off
set action=NEWLOG
:FIX
mkdir %DRIVE%:\log_file
CLS
GOTO STATE

:FIXLOG
@ECHO Off
set action=FIXLOG
RENAME %DRIVE%:\log_file log_file_backup

GOTO FIX

:State
ECHO %ACTION% performed against drive "%DRIVE%" with input %INPUT% >>%cd%\log.txt
CLS
GOTO BEGIN
:EOF
